-------------------------------------------------------------------
--  Q103 (" ")
-------------------------------------------------------------------


-------------------------------------------------------------------
local QUEST_ID = "Q103"
local TARGET_CITIES = {"Rosieny", "Novgorodok"}
local ENEMY_PLAYER = "Prussia"
local PERSON_LEVEL = 15
local PERSON_SQUADS = "Commander1, 1, Infantry1, 2"
local BONUS_LOYALTY = 15
local BONUS_SQUADS_ID = {"EliteCavalry1_EastEuropean"}
local BONUS_SQUADS_COUNT = {2}
-------------------------------------------------------------------


-------------------------------------------------------------------
function sl_quest_can_activate_Q103(params)

  	return	isQuestFulfilled("Q102") and
  			isPlayerLive(getPlayer(ENEMY_PLAYER)) and
  			isPolishPlayer(getMyPlayer()) and
  			hasPlayerPolandZone(getMyPlayer())

end


-------------------------------------------------------------------
function sl_quest_activate_Q103(params)

	--   
	local enemy = getPlayer(ENEMY_PLAYER)
	local n = table.getn(TARGET_CITIES)
	for i = 1, n do
	
		local city = getCity(TARGET_CITIES[i])
		giveCityToPlayer(city, enemy, true);
		sl_quest_add_zone_link_to_params(city, params, "iCityId" .. i, "sCity" .. i)
		
	end

	--       
	local city = getCity(TARGET_CITIES[getRangeRandom(1, n)])
	sl_quest_create_general(enemy, PERSON_LEVEL, city, PERSON_SQUADS, params, "iPersonId")
	params:setBool("bIsPersonDefeat", false)

 	addEventHandler("E_OnCityCapture",	"sl_quest_Q103_handler_E_OnCityCapture")
 	addEventHandler("E_OnPersonDefeat",	"sl_quest_Q103_handler_E_OnPersonDefeat")
 	
end


-------------------------------------------------------------------
function sl_quest_deactivate_Q103(params)

	removeEventHandler("E_OnCityCapture",	"sl_quest_Q103_handler_E_OnCityCapture")
	removeEventHandler("E_OnPersonDefeat",	"sl_quest_Q103_handler_E_OnPersonDefeat")

end


-------------------------------------------------------------------
function sl_quest_Q103_check_fulfilment()
	
	local n = table.getn(TARGET_CITIES)
	for i = 1, n do
	
		local city = getCity(TARGET_CITIES[i])
		if not city:getPlayer():isMyPlayer() then
			return
		end

	end
	
   	if getQuestParams(QUEST_ID):getBool("bIsPersonDefeat") then
  		fulfilQuest(QUEST_ID)
   	end
	
end


-------------------------------------------------------------------
function sl_quest_Q103_handler_E_OnCityCapture(params)

	sl_quest_Q103_check_fulfilment()
   	
end


-------------------------------------------------------------------
function sl_quest_Q103_handler_E_OnPersonDefeat(params)

	local questParams = getQuestParams(QUEST_ID)
	if params:getInt("iPersonId") == questParams:getInt("iPersonId") then
		
		questParams:setBool("bIsPersonDefeat", true)
		sl_quest_Q103_check_fulfilment()
		
	end
	
end


-------------------------------------------------------------------
function sl_quest_bonus_Q103(params)

	addCitiesLoyalty(getMyPlayer(), BONUS_LOYALTY)
	bonus_giveArmy(params, BONUS_SQUADS_ID, BONUS_SQUADS_COUNT)
	
end


