-------------------------------------------------------------------
--  Q112 ("- ")
-------------------------------------------------------------------


-------------------------------------------------------------------
local QUEST_ID = "Q112"
local ENEMY_PLAYER = "Prussia"
local TARGET_PLAYERS = {"Litva", "Polotzk"}
local NEED_GOLD = 2000
local PENALTY_DREL = -1
local LITVA_GIFT_SQUADS = "Cart1, 2, Infantry1, 5, LightCavalry1, 5, HeavyCavalry1, 3, Commander1, 1"

-------------------------------------------------------------------


-------------------------------------------------------------------
function sl_quest_can_activate_Q112(params)

	if not isPolishPlayer(getMyPlayer()) then
		return false
	end
	
	if not isPlayerLive(getPlayer(ENEMY_PLAYER)) then
		return false
	end
	
	local tPlayer = nil
	local n = table.getn(TARGET_PLAYERS)
	for i = 1, n do
		local tmpPlayer = getPlayer(TARGET_PLAYERS[i])
		if isPlayerLive(tmpPlayer) then
			tPlayer = tmpPlayer
			break
		end
	end
	
	if tPlayer == nil then
		return false
	end
	
	if params ~= nil then
	
		params:setInt("iGold", NEED_GOLD)
		params:setInt("iTPlayerId", tPlayer:getId())
		params:setStringW("sTPlayer", getPlayerNameW(tPlayer))
		
		addEventHandler("E_OnAmbassadorArrival", "sl_quest_Q112_handler_E_OnAmbassadorArrival")
		
	end
	
	return true
	
end


-------------------------------------------------------------------
function sl_quest_deactivate_Q112(params)

	removeEventHandler("E_OnAmbassadorArrival", "sl_quest_Q112_handler_E_OnAmbassadorArrival")

end


-------------------------------------------------------------------
function sl_quest_before_desc_show_Q112(params)

	local city = getPlayerById(params:getInt("iTPlayerId")):getCities():getCapital()
	if city ~= nil then
		params:setInt("iCityId", city:getId())
		params:setStringW("sCity", getCityNameW(city))
	end

end


-------------------------------------------------------------------
function sl_quest_Q112_handler_E_OnAmbassadorArrival(params)

	local questParams = getQuestParams(QUEST_ID)
	
	--       ?
	if	params:getInt("iPlayerId") ~= getMyPlayer():getId() then
		return
	end
	
	--       ?
	local tPlayer = getPlayerById(questParams:getInt("iTPlayerId"));
	if params:getInt("iCityId") ~= tPlayer:getCities():getCapital():getId() then
		return
	end

	--    ?
	if getResourceFromPlayer(getMyPlayer(), RT_GOLD) >= NEED_GOLD then
		fulfilQuest(QUEST_ID)
	end
	
end


-------------------------------------------------------------------
function sl_quest_bonus_Q112(params)

	local myPlayer = getMyPlayer()
	local tPlayer = getPlayerById(params:getInt("iTPlayerId"))
		
	--  
	addResourceToPlayer(myPlayer, RT_GOLD, -NEED_GOLD)
	addResourceToPlayer(tPlayer, RT_GOLD, NEED_GOLD)
	
	--  
	myPlayer:getDiplomacy():makePerpetualPeace(tPlayer)
	
	--    
	local enemy = getPlayer(ENEMY_PLAYER)
	if isPlayerLive(enemy) then
		myPlayer:getDiplomacy():makeWar(enemy, false)
		tPlayer:getDiplomacy():makeWar(enemy, false)
	end
	
end


-------------------------------------------------------------------
function sl_quest_penalty_Q112(params)

	local tPlayer = getPlayerById(params:getInt("iTPlayerId"))
	if not isPlayerLive(tPlayer) then
		return
	end
	
	--     
	getMyPlayer():getDiplomacy():changeRelationValueLevel(tPlayer, PENALTY_DREL)
	
	params:setStringW("Relations", getReleationLevelW(getMyPlayer():getDiplomacy():getRelationValue(tPlayer), true))
	
	--      
	local person = sl_quest_add_new_person_to_player(tPlayer, "General", tPlayer:getCities():getCapital())
	if person ~= nil then
		setPersonProfLevel(person, "General", 15)
		addSquadsToEntityByCulture(person, LITVA_GIFT_SQUADS, "EastEuropean")
		person:setAILocked(false)
	end
	
end