-------------------------------------------------------------------
--  T2_1 (" ")
-------------------------------------------------------------------


-------------------------------------------------------------------
local QUEST_ID = "T2_1"
-------------------------------------------------------------------


-------------------------------------------------------------------
function sl_quest_can_activate_T2_1(params)

	if not isQuestCompleted("T2") then
		return false
	end
	
	local city = getMyPlayer():getCities():getCapital()
	
	local building = city:getBuildings():getBuilding("Smithy1")
	if not building:isBuilt() then
		return false
	end
	
	city:getEmployment():setEmployees(getEmploymentSphereTypeByName("Gold"), 0)
	sl_quest_add_city_link_to_params(city, params, "iCityId", "sCity")
	
	params:setBool("bIsNeedBuildingsBtnLighting", true)
	
	addEventHandler("E_OnGuiPanelShow", "sl_quest_T2_1_handler_E_OnGuiPanelShow")
		
	return true
		
end


-------------------------------------------------------------------
function sl_quest_deactivate_T2_1(params)

	stopBlinkGuiElement("CityPanel_Buildings_Btn")
	stopBlinkGuiElement("CityBuildings_SliderGold/ScrollBar/ScrollBit")

	removeEventHandler("E_OnGuiPanelShow", "sl_quest_T2_1_handler_E_OnGuiPanelShow")
	
end


-------------------------------------------------------------------
function sl_quest_T2_1_handler_E_OnGuiPanelShow(params)

	--    ,     
	local city = getSelectedCity()
	if city == nil then
		return
	end

	--    ,      
	local questParams = getQuestParams(QUEST_ID)
	if city:getId() ~= questParams:getInt("iCityId") then
		stopBlinkGuiElement("CityPanel_Buildings_Btn")
		stopBlinkGuiElement("CityBuildings_SliderGold/ScrollBar/ScrollBit")
		return
	end

	--   
	local panelName = params:getString("Name")	
	if panelName == "CityPanel" and questParams:getBool("bIsNeedBuildingsBtnLighting") then
	
		local btn = ge_get_btn("CityPanel_Buildings_Btn")
		startBlinkBtnHL(btn:get_name(), 0)
		lowerBlinkElement(btn, 1)
		
	end
	
	--    
	if panelName == "CityBuildingsPanel" then
	
		stopBlinkGuiElement("CityPanel_Buildings_Btn")
		questParams:setBool("bIsNeedBuildingsBtnLighting", false)
		
		local btn = ge_get("CityBuildings_SliderGold/ScrollBar/ScrollBit")
		startBlinkGuiElement(btn:get_name(), 0, "default_lighting_mat")
		
	end
	

end


-------------------------------------------------------------------
function sl_quest_check_fulfilment_T2_1(params)

	local employment = getCityById(params:getInt("iCityId")):getEmployment()
	local emplType = getEmploymentSphereTypeByName("Gold");
	if employment:getEmployees(emplType) >= employment:getLimit(emplType) * 0.95 then
		return true
	end

	return false

end


-------------------------------------------------------------------
function sl_quest_bonus_T2_1(params)

	sl_quest_deactivate_T2_1(params)
	runQuest("T3")
	
end


-------------------------------------------------------------------
function sl_quest_penalty_T2_1(params)

	sl_quest_deactivate_T2_1(params)
	sl_quest_on_tutorial_quest_failure()
	runQuest("T3")
	
end